import Flutter

import UIKit
import AVFoundation
import Foundation
import AVKit

public class SwiftHlsPlayerPlugin: UIViewController, FlutterPlugin {


  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "hls_player", binaryMessenger: registrar.messenger())
    let instance = SwiftHlsPlayerPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {

        switch call.method {
                            case "initializeVideo":
                            
                                  guard let args = call.arguments else {
                                          result("iOS could not recognize flutter arguments in method: ( \(call.method))") 
                                          return
                                        }

                                      if let myArgs = args as? [String: String],
                                          let url = myArgs["url"] as? String {

                                            
                                                  //Present your ViewController only if its not present to the user currently.
                                                  let AVPlayerVideo : ViewController_AVPlayer_Video = ViewController_AVPlayer_Video() ;
                                                  AVPlayerVideo.isBuild( "https://mnmedias.api.telequebec.tv/m3u8/29880.m3u8", userCompletionHandler: {mensaje, error in
           
                result(mensaje) 
        })
                                        } else {
                                          result(FlutterError(code: "-1", message: "iOS could not extract " + 
                                            "flutter arguments 'url' in method: ( \(call.method))", details: nil))
                                        } 
                break;


               case "initializeZapping":
        
                                      guard let args = call.arguments else {
                                      result("iOS could not recognize flutter arguments in method: ( \(call.method))") 
                                      return
                                    }

                                  if let myArgs = args as? [String: Any],
                                      let canales = myArgs["canales"] as? Array<String>,
                                      let playVideoAtIndex = myArgs["playVideoAtIndex"] as? Int {


                                        let AVPlayerZapping : ViewController_AVPlayer_List = ViewController_AVPlayer_List() ;
                                        AVPlayerZapping.canales = canales
                                        AVPlayerZapping.playVideoIndex = playVideoAtIndex


                                        DispatchQueue.main.async { UIApplication.shared.keyWindow?.rootViewController?.present(AVPlayerZapping, animated: true, completion: nil);  }
                                                  
                                                  
                                                      // if( AVPlayerZapping.isBeingPresented) {

                                                      //     result(canales)
                                                      // }else{
                                                      //     result(FlutterError(code: "-1", message: "No fue abierto el Controlador \(call.method)", details: nil))
                                                      // }

                                                          result(canales)
                                                        
                                  } else {
                                          result(FlutterError(code: "-1", message: "iOS could not extract " + 
                                            "flutter arguments 'canales' in method: ( \(call.method))", details: nil))
                                  }
 
                        break;

          default:
              result(FlutterMethodNotImplemented)
                
        }
      
       
    }
        


  



}
 