import 'dart:async';

import 'package:flutter/services.dart';
import 'package:meta/meta.dart';

class HlsPlayer {
  static const MethodChannel _channel = const MethodChannel('hls_player');

  static Future<String> initializeVideo(
      {@Required('url parameter required') String url}) async {
    final String urlEnviada = await _channel.invokeMethod(
      'initializeVideo',
      <String, String>{'url': url},
    );
    return urlEnviada;
  }

  static Future<List> initializeZapping(
      {@Required('canales parameter required')
          List canales,
      @Required('playVideoAtIndex parameter required')
          int playVideoAtIndex}) async {
    final canalesEnviados = await _channel.invokeMethod(
      'initializeZapping',
      <String, dynamic>{
        'canales': canales,
        'playVideoAtIndex': playVideoAtIndex,
      },
    );
    return canalesEnviados;
  }
}
